import gevent.monkey
gevent.monkey.patch_all()
import random
import requests
import time
from xml.etree import ElementTree

from locust import HttpUser, task, between


wcs_list = []


def get_requests (url, user, password):
        response = requests.get(url = url, auth = (user, password))

        catalog = ElementTree.fromstring(response.content)
        entries = catalog.findall('{http://www.w3.org/2005/Atom}entry')

        for entry in entries :
            wcs_offers = entry.findall('{http://www.opengis.net/owc/1.0}offering[@code="http://www.opengis.net/spec/owc-atom/1.0/req/wcs"]')
            for offer in wcs_offers :
                services = offer.findall('{http://www.opengis.net/owc/1.0}operation[@code="GetCoverage"]')
                if len(services) > 0 :
                    modified_request = '%s&scalesize=x(50),y(50)' % (services[0].get('href').replace('https://emg.pdas.prism.eox.at/',''))
                    wcs_list.append(modified_request)

# replace the strings 'username' and 'Password' with the pdas/vs credintials 
get_requests('http://vhr18.pdas.prism.eox.at/opensearch/collections/VHR_IMAGE_2018_Level_3/atom', 'username', 'password')

class QuickstartUser(HttpUser):


    wait_time = between(0, 0)

    @task(3)
    def view_item(self):
       item_id = random.randint(0, len(wcs_list)-1)
       item = wcs_list[item_id]
       # replace the strings 'username' and 'Password' with the pdas/vs credintials 

       self.client.get(f"{item}", auth=('username', 'password'))
    
